package no.inspera.services.pedal.actions;

import no.inspera.services.pedal.PEDAL;
import no.inspera.utils.Parameters;

/**
 * An empty action.
 *
 * @author <a href="mailto:naimdjon@gmail.com">Naimdjon Takhirov</a>
 * @version $Id: Empty.java 45069 2008-05-29 08:25:25Z naimdjon $
 * @since 23.12.2007
 */
public class Empty implements Action {

    /**
     * An empty action.
     *
     * @param params current request parameters.
     * @return an empty {@link HTML} result  
     */
    public Result execute(Parameters params) {
        return new HTML("<html><head><link rel=\"stylesheet\" type=\"text/css\" href=\""+ PEDAL.startPage+"/course.css\"/></head><body></body></html>");
    }
}