package no.inspera.services.pedal.actions;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * This object represents a result of the action in the personalised course page.
 *
 * @author <a href="mailto:naimdjon@gmail.com">Naimdjon Takhirov</a>
 * @version $Id: Result.java 45069 2008-05-29 08:25:25Z naimdjon $
 * @since 15.12.2007 
 */
public interface Result {

    /**
     * Processes result. 
     *
     * @param request current request.
     * @param response current reponse.
     * @throws ServletException if any exception occurs when forwarding.
     */
     public void processResult(HttpServletRequest request, HttpServletResponse response)throws ServletException;
    
}
