<%@ page import="no.inspera.db.BaseObjectDataAccess" %>
<%@ page import="no.inspera.db.DataAccess" %>
<%@ page import="no.inspera.db.TableColumns" %>
<%@ page import="no.inspera.utils.Parameters" %>
<%@ page import="no.inspera.utils.StringUtils" %>
<%@ page import="no.inspera.services.pedal.utils.ICollections" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.util.Collection" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%
    java.util.Map<String,Iterable<String>> sampleSQLs= ICollections.newMap();
    Collection<String> col= ICollections.linkedList();
    col.add("select * from persons");
    col.add("select * from persons where firstname like 'Naimdjon'");
    col.add("select firstname from persons where city = 'Oslo'");
    sampleSQLs.put("select",col);
    col= ICollections.linkedList();
    col.add("update persons set firstname='Naimjon' where lastname='Takhirov'");
    col.add("update persons set city='Trondheim', address='Strindheim 23'  where lastname='Takhirov'");
    sampleSQLs.put("update",col);
    col= ICollections.linkedList();
    col.add("delete persons where lastname='Takhirov'");
    col.add("delete persons where lastname='Takhirov' and firstname='Naimdjon'");
    sampleSQLs.put("delete",col);
    col= ICollections.linkedList();
    col.add("insert into persons values(20,'Your firstname','Your lastname','Your address','Your city')");
    col.add("insert into persons (personid,firstname,lastname,address,city) values(21,'Your firstname','Your lastname','Your address','Your city')");
    sampleSQLs.put("insert",col);
    final Parameters params=Parameters.create(request);
    Connection con =null;
    Statement st=null; 
    try{
        con = DriverManager.getConnection("jdbc:oracle:thin:@utv_db:1521:utvdb4","booking_dontdelete","booking_dontdelete");
        st = con.createStatement();
        final String query = request.getParameter("query");%>

<html>
  <head><title>Practice SQL</title>
      <link rel="stylesheet" type="text/css" href="/jsp/pedal-ng/course.css"/>
  </head>
  <body>
      <table width="100%">
          <tr>
              <td valign="top">
                  <table>
                      <tr>
                          <td>
                              <%
                                  String q = params.getParameter("query");
                                  String statementSample;
                                  if(q==null){
                                      statementSample=params.getParameter("sample", "select");
                                  }else if (!StringUtils.anyStartsWithIgnoreCase(q, "select", "update", "insert", "delete")) {
                                      %><div class="error">An SQL statement should start with "select", "update", "insert" or "delete"</div>  <%
                                      statementSample=params.getParameter("sample", "select");
                                  }else
                                     statementSample =q.substring(0,q.indexOf(" ")).toLowerCase();
                              %>
                              <h2>Practice SQL <%=statementSample.toUpperCase()%></h2>
                              On the left side there is table "Persons". Practice SQL by  execute query:
                              <br/>
                                  <%
                                      System.out.println("statementSample:"+statementSample);
                                      Iterable<String> sample=sampleSQLs.get(statementSample);
                                %>
                              <label for="sample"> Sample queries:</label>
                              <ul id="sample">
                              <%
                                      for (String s : sample) {
                                          %><li class="sql"><i><%=s%></i></li><%
                                      }
                                  %>
                              </ul>
                          </td>
                      </tr>
                      <tr>
                          <td><hr/></td>
                      </tr>
                      <tr>
                          <td><input id="query" style="width:400px;" type="text" value="<%=StringUtils.checkNull(query)%>"/>&#160;<input value="Submit" type="button" onclick="document.location.href='<%=request.getRequestURL().toString()+"?sample="+statementSample+"&query="%>'+document.getElementById('query').value"/> </td>
                      </tr>
                      <tr>
                          <td>
                              <%
                                  if(StringUtils.hasLength(query)){
                                      try {
                                          if(query.toLowerCase().startsWith("select")){
                                              System.out.println("select...");
                                          final ResultSet rs = st.executeQuery(query);
                                          final ResultSetMetaData md = rs.getMetaData();
                                          final int cc = md.getColumnCount();
                                          %>
                                            <table class="borderTable">
                                                <thead>
                                            <%
                                          for (int i = 1; i <=cc; i++) {
                                              final String columnName = md.getColumnName(i);
                                              %><th><%=columnName%></th><%
                                          }
                                                %></thead><%
                                          while (rs.next()) {
                                              %><tr><%
                                              for (int i = 1; i <=cc; i++) {
                                                  %><td><%=rs.getObject(i)%></td><%
                                              }
                                            %></tr><%
                                          }
                                           %></table><%
                                      }else if(StringUtils.anyStartsWithIgnoreCase(query,"delete","update","insert")){
                                          System.out.println("up...");
                                          final int i = st.executeUpdate(query);
                                          %><div><i><em><%=StringUtils.capitalize(statementSample)%><%=statementSample.endsWith("e")?"d":"ed"%>  <%=i%> row<%=i>1?"s":""%> in the database!</em></i></div><%
                                      }
                                      } catch (Exception e) {
                                          e.printStackTrace();
                                          %><div  class="error">Error:<%=e.getMessage().startsWith("ORA")?e.getMessage().substring(e.getMessage().indexOf(":")+1):e.getMessage()%></div><%
                                      }
                              }
                              %>
                          </td>
                      </tr>
                  </table>
              </td>
              <td valign="top">
                    <table>
                        <tr>
                            <td>Persons table</td>
                        </tr>
                        <tr>
                            <table class="borderTable">
                                <%
                                    DataAccess db= BaseObjectDataAccess.getInstance();
                                    final TableColumns tableColumns = db.getTableColumns(con, "PERSONS");
                                    for (String s : tableColumns.getColumnNames()) {
                                        %><th><%=s%></th><%
                                    }
                                    final ResultSet rs = st.executeQuery("select * from persons");
                                    while (rs.next()) {
                                        %>
                                            <tr>
                                                <%
                                                    for (String s : tableColumns.getColumnNames()) {
                                                        %><td><%=rs.getObject(s)%></td><%
                                                    }
                                                %>
                                            </tr>
                                           <%
                                    }
                                %>
                            </table>
                        </tr>
                    </table>
              </td>
          </tr>
      </table>
  </body>
</html>
<%
    }catch(Exception e){
        e.printStackTrace();
    }finally{
        st.close();
        con.close();
    }
%>