<%@ page import="no.inspera.db.UserDataAccess" %>
<%@ page import="no.inspera.kernel.User" %>
<%@ page import="no.inspera.services.resourcestring.ResourceStringService" %>
<%@ page import="no.inspera.utils.Parameters" %>

<%
    Parameters params= Parameters.create(request);
    final String username = params.getParameter("username");
    final String password = params.getParameter("password");
    //System.out.println("username:"+username+", password:"+password);
    response.setContentType("text/xml");
    final ServletOutputStream outputStream = response.getOutputStream();

    try {
        final Long userId = UserDataAccess.getInstance().checkPassword(username, password, params.getMarketplaceId());
        final User user = UserDataAccess.getInstance().getUser(userId);
        response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
        response.setHeader("Pragma","no-cache"); //HTTP 1.0
        response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
        params.setSessionAttribute("returnLogOutURL",request.getRequestURL().toString().replace("login/auth.jsp",""));
        params.setUserId(userId);
        params.setMarketplaceId(user.getMarketplaceId());
        params.setLanguageId(user.getLanguageId());
        outputStream.print("<msg>Welcome "+user.getFirstName()+"  "+user.getLastName()+"</msg>");
    } catch (Exception e) {
        outputStream.print("<msg>Error:"+ ResourceStringService.getResourceString(e.getMessage(),params.getLanguageId(),params.getMarketplaceId(),false) +"</msg>");
    }

%>