<%@ page import="no.inspera.db.MetadataDataAccess" %>
<%@ page import="no.inspera.db.RelationDataAccess" %>
<%@ page import="no.inspera.db.UserDataAccess" %>
<%@ page import="no.inspera.kernel.User" %>
<%@ page import="no.inspera.services.metadataservice.*" %>
<%@ page import="no.inspera.services.relation.MembershipRelation" %>
<%@ page import="no.inspera.services.relation.RelationTypeConstants" %>
<%@ page import="no.inspera.utils.CommonTools" %>
<%@ page import="no.inspera.utils.Parameters" %>
<%@ page import="no.inspera.utils.StringUtils" %>

<%
    final long orgID=629805;
    Parameters params= Parameters.create(request);
    final String email = request.getParameter("email");
    final String firstname = request.getParameter("firstname");
    final String lastname = request.getParameter("lastname");
    final String mobile = request.getParameter("mobile");
    final String password = request.getParameter("password");
    final String[] interests = request.getParameterValues("interests");
    final User user = UserDataAccess.getInstance().getUserByEmail(email, params.getMarketplaceId());
    response.setContentType("text/xml");
    final ServletOutputStream outputStream = response.getOutputStream();
    if (!CommonTools.isValidEmail(email)) {
        outputStream.print("<msg>Invalid email address!</msg>");
    }else if(user!=null){
        outputStream.print("<msg>Email is already registered!</msg>");
    }else if(!StringUtils.hasLength(firstname)){
        outputStream.print("<msg>First name missing!</msg>");
    }else if(!StringUtils.hasLength(lastname)){
        outputStream.print("<msg>Last name missing!</msg>");
    }else if(!StringUtils.hasLength(password)){
        outputStream.print("<msg>Password missing!</msg>");
    }else {
        User u= new User();
        try {
            u.setFirstName(firstname);
            u.setLastName(lastname);
            u.setEmail(email);
            u.setPassword(password);
            u.setUserName(email);
            u.setLanguageId(2);
            u.setURL(mobile);
            u.setMarketplaceId(params.getMarketplaceId());
            final Long userId = UserDataAccess.getInstance().createNewUser(u);
            MembershipRelation rel = new MembershipRelation(orgID, userId, RelationTypeConstants.EMPLOYEE_STUDENT, params.getMarketplaceId());
            RelationDataAccess.getInstance().newMembershipRelation(rel);
            if (interests != null && interests.length > 0) {
                Metadata md= new Metadata();
                md.setObjectId(userId);
                ItemProperty ip= MetadataService.getItemProperty("interests");
                ItemValue iv= new ItemValue();
                iv.setItemProperty(ip.getItemPropertyId());
                iv.setObjectId(userId);
                iv.setLanguageId(0L);
                for (String s : interests) {
                    ItemPropertyValue ipv= new ItemPropertyValue();
                    ipv.setValue(Long.valueOf(s));
                    iv.addValue(ipv);
                }
                md.addMetadataItem(iv);
                MetadataDataAccess.getInstance().storeMetaData(md.getItemValues(),userId);
            }
        } catch (Exception e) {
            e.printStackTrace();
            outputStream.print("<msg>Error creating a user!</msg>");
            return;
        }
        outputStream.print("<msg>User is created!</msg>");
    }
%>