<%@ page import="no.inspera.utils.xpath.XPath" %>
<%@ page import="no.inspera.utils.XMLTools" %>
<%@ page import="org.w3c.dom.Document" %>
<%@ page import="no.inspera.utils.FileUtils" %>
<%@ page import="org.w3c.dom.Node" %>
<%@ page import="org.xml.sax.SAXException" %>
<%@ page import="org.w3c.dom.traversal.NodeIterator" %>
<%@ page import="no.inspera.utils.collections.ICollections" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.ArrayList" %>

<%
    response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
    response.setHeader("Pragma","no-cache"); //HTTP 1.0
    response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
%>

<div>
    <em>Welcome to learning style questionnaire. The system will try to identify your learning style based on answers you give below.</em>
</div>
<div style="font-size:10px;padding-top:2px;">
    <hr/>
        &#169; Copyright Version 7.0 (2006) held by Neil D. Fleming, Christchurch, New Zealand and Charles C. Bonwell, Green Mountain Falls, Colorado
        80819 U.S.A.  <br/><a href="http://www.vark-learn.com" style="color:#ccccdd;" target="_blank">VARK web-site</a>
</div>
<%
    try {
        Document doc= XMLTools.getDocument(FileUtils.readFile(config.getServletContext().getRealPath("/jsp/pedal-ng/lsa/questions.xml")));
        final NodeIterator it = XPath.selectNodeIterator(doc, "/vark-questions/question");
        for (Node questionNode = it.nextNode(); questionNode != null; questionNode = it.nextNode()) {
            String q= XPath.eval(questionNode,"q");
            String id= XPath.eval(questionNode,"@id");
            %>
            <div class="VARKQuestion">
                <hr/>
                   <div class="VARKQuestionText"><%=id+"/16.   "+  q%></div>
            <%
                Map<String,String> map= ICollections.newMap();
                final NodeIterator responseIterator = XPath.selectNodeIterator(questionNode, "response");
            for (Node responseNode = responseIterator.nextNode(); responseNode != null; responseNode = responseIterator.nextNode()) {
                final String type = XPath.eval(responseNode, "@type");
                final String text = XPath.eval(responseNode, ".");
                map.put(type,text);

            }
                final ArrayList<String> list = new ArrayList<String>(map.keySet());
                java.util.Collections.shuffle(list);
                for (String type : list) {
                    %>
                        <div class="VARKResponse">
                            <label>
                            <input type="checkbox" value="<%=type%>" name="<%=type%>"/>
                            <%=map.get(type)%>
                        </label>
                            </div>
                      <%
                }
            %>


            </div><%
        }
        %></div><%
    } catch (SAXException e) {
        e.printStackTrace();
        %>Error:<%=e.getMessage()%><%
    }
%>
