<%@ page import="no.inspera.applications.publish.datamodel.ContentRevision" %>
<%@ page import="no.inspera.applications.publish.datamodel.assessment.AssessmentDataAccess" %>
<%@ page import="no.inspera.applications.publish.datamodel.assessment.QTIUserAssessment" %>
<%@ page import="no.inspera.db.BaseObjectDataAccess" %>
<%@ page import="no.inspera.db.ContentPresentationDataAccess" %>
<%@ page import="no.inspera.services.metadataservice.*" %>
<%@ page import="no.inspera.services.pedal.PEDAL" %>
<%@ page import="no.inspera.utils.Parameters" %>

<%
    Parameters params= Parameters.create(request);
    //String req=request.getRequestURL().toString().replace("index.jsp","");
    String url="/content?marketplaceId="+params.getMarketplaceId()+"&contentItemId=629886";
    if (params.getUserId() <= 0) {
        %>You have to login to take prior knowledge assessment<%
        return;
    }else {
            final Metadata md = MetadataService.getMetadataForObject(params.getUserId());
            if (md != null) {
                ItemValue iv=md.getItemValue(PEDAL.level);
                if (iv != null && iv.getItemValueId() != null && iv.getItemValueId() > 0) {
                    final ItemProperty itemproperty = MetadataService.getItemProperty(iv.getItemProperty());
                    final ItemPropertyValue[] values = itemproperty.getValues();
                    ItemPropertyValue value=null;
                    for (ItemPropertyValue val : values) {
                        if (iv.getValueNumber().equals(val.getItemPropertyValueId()))
                            value=val;
                    }
                    final String logicalTitle = params.getParameter("pedalCourseLogicalTitle",PEDAL.defaultLogicalTitle, true);
                    long contentItemId = BaseObjectDataAccess.getInstance().getObjectIdFromLogicalName(logicalTitle, params.getMarketplaceId());
                    ContentRevision revision = ContentPresentationDataAccess.getInstance().getLiveContentRevisionWithEffectiveLanguage(contentItemId, params.getLanguageId(), params.getMarketplaceId());
                    final ItemValue ivAss = MetadataService.getMetadataForObject(revision.getObjectId()).getItemValue(PEDAL.prior_knowledge_assessment);
                    final ContentRevision assessment = ContentPresentationDataAccess.getInstance().getLiveContentRevisionWithEffectiveLanguage(Long.valueOf(ivAss.getValueText()), params.getLanguageId(), params.getMarketplaceId());
                    final QTIUserAssessment ua = AssessmentDataAccess.getInstance().getLastUserAssessment(assessment.getContentRevisionId(), params.getUserId());
                    if(ua!=null && value!=null){
                        %>You've taken this assessment.   <a href="<%=url%>">Take again</a>.<%
                    }else
                        %><jsp:forward page="<%=url%>"/><%
                }else {
                    //response.sendRedirect(url);
                    %><jsp:forward page="<%=url%>"/><%
                }
            }
        }
%>