package no.inspera.services.pedal.engine;

import no.inspera.services.pedal.Module;

/**
 * The <tt>Sequence</tt> interface does sequencing of LearningObject that are in a module.
 *
 * @author <a href="mailto:naimdjon@gmail.com">Naimdjon Takhirov</a>
 * @version $Id: Sequence.java 45069 2008-05-29 08:25:25Z naimdjon $
 * @since 27.12.2007
 */
public interface Sequence {

    /**
     *  Sequences LearningObjects that are in the module.
     *
     * @param chain the sequencing chain
     * @param module the current module 
     */
    public void doSequence(Chain chain, Module module);
    
}
