<%@ page import="no.inspera.utils.CommonTools" %>
<%@ page import="no.inspera.db.UserDataAccess" %>
<%@ page import="no.inspera.utils.Parameters" %>
<%@ page import="no.inspera.kernel.User" %>

<%
    Parameters params= Parameters.create(request);
    final String email = request.getParameter("email");
    response.setContentType("text/xml");
    final ServletOutputStream outputStream = response.getOutputStream();
    if (!CommonTools.isValidEmail(email)) {
        outputStream.print("<msg>Invalid email address!</msg>");
    }else {
        final User user = UserDataAccess.getInstance().getUserByEmail(email, params.getMarketplaceId());
        if(user==null){
            outputStream.print("<msg>User with this email is not registered!</msg>");
        }else{
            try {
                User u=UserDataAccess.getInstance().getUserToSendPassword(user.getEmail(),params.getMarketplaceId());
                CommonTools.sendUserRequestedPassword(params,u,params.getMarketplaceObj());
                outputStream.print("<msg>Password has been sent. Please check also your junk-mail folder if you don't find the email in your inbox.</msg>");
            } catch (Exception e) {
                e.printStackTrace();
                outputStream.print("<msg>Error:"+e.getMessage()+"</msg>");
            }
        }
    }
%>