<%@ page import="no.inspera.applications.publish.datamodel.ContentRevision" %>
<%@ page import="no.inspera.db.BaseObjectDataAccess" %>
<%@ page import="no.inspera.db.ContentPresentationDataAccess" %>
<%@ page import="no.inspera.db.MetadataDataAccess" %>
<%@ page import="no.inspera.services.log.LogServices" %>
<%@ page import="no.inspera.services.metadataservice.*" %>
<%@ page import="no.inspera.services.pedal.PEDAL" %>
<%@ page import="no.inspera.services.pedal.actions.Configure" %>
<%@ page import="no.inspera.services.pedal.actions.Index" %>
<%@ page import="no.inspera.utils.Parameters" %>
<%@ page import="no.inspera.utils.collections.ICollections" %>
<%@ page import="org.apache.log4j.Logger" %>
<%!
    private final transient Logger log = LogServices.getLogger(getClass());
    static java.util.Map<String,String>mappings= ICollections.newMap();
    static {
        mappings.put("V", PEDAL.LearningStyle.visual.s());
        mappings.put("A", PEDAL.LearningStyle.auditory.s());
        mappings.put("K", PEDAL.LearningStyle.kinesthetic.s());
    }

    class VARK implements Comparable<VARK>{
        int score;
        String type;

        VARK(int score, String type) {
            this.score = score;
            this.type = type;
        }

        public String toString() {
            return "score:"+ score +", t:"+type;
        }

        public int compareTo(VARK o) {
            return (this.score<o.score ? -1 : (this.score==o.score ? 0 : 1));
        }
    }

    VARK count(String s,Parameters params) {
        final String[] values = params.getParameterValues(s);
        if (values != null && values.length > 0)
            return new VARK(values.length,s);
        return new VARK(0,s);
    }
%>
<%
    Parameters params=Parameters.create(request);
    params.logParams();
    VARK[] reponses = new VARK[]{
            count("V",params),
            count("A",params),
//            count("R",params),
            count("K",params)
    };
    java.util.Arrays.sort(reponses);
    String type = reponses[2].type;
    
    try {
        final Metadata md = MetadataService.getMetadataForObject(params.getUserId());
        final ItemProperty itemproperty = MetadataService.getItemProperty(PEDAL.learningStyle);
        ItemValue iv = md.getItemValue(itemproperty.getItemPropertyId());
        final ItemPropertyValue[] values = itemproperty.getValues();
        ItemPropertyValue ipv=null;
        for (ItemPropertyValue value : values) {
            if (value.getLogicalName().equals(mappings.get(type))) 
                ipv=value;
        }
        if(ipv!=null){
            System.out.println("ipv.getItemPropertyValueId():"+ipv.getItemPropertyValueId());
            ipv.setIsSet(true);
        }
        if (iv == null) {
            iv= new ItemValue();
            iv.setItemProperty(itemproperty.getItemPropertyId());
            iv.setObjectId(params.getUserId());
            iv.setValueNumber(ipv.getItemPropertyValueId());
            MetadataDataAccess.getInstance().addItemValueValueNumber(iv);
        }else {
            iv.setValueNumber(ipv.getItemPropertyValueId());
            MetadataDataAccess.getInstance().updateItemValue(iv);
        }
        long contentItemId = BaseObjectDataAccess.getInstance().getObjectIdFromLogicalName((String) params.getSessionAttribute("pedalCourseLogicalTitle"), params.getMarketplaceId());
        MetadataService.removeMetadataForObjectFromCache(params.getUserId());
        ContentRevision revision = ContentPresentationDataAccess.getInstance().getLiveContentRevisionWithEffectiveLanguage(contentItemId, params.getLanguageId(), params.getMarketplaceId());
         params.setRequestAttribute(PEDAL.course, revision);
        new Configure(params.getMarketplaceId(), params.getLanguageId()).execute(params);
        new Index().execute(params);
        %>
          <body onload="javascript:parent.scroll(0,0);"/>
        <p>Great. Now you can click "Next" to continue the course. </p>
    <%
    } catch (Exception e) {
        log.error("Exception",e);
        %>An error occurred. <a href="/jsp/pedal-ng/lsa">Please try again</a>.<%
    }
%>