<%@ page import="no.inspera.db.BaseObjectDataAccess" %>
<%@ page import="no.inspera.db.MarketplaceDataAccess" %>
<%@ page import="no.inspera.Marketplace" %>
<%@ page import="no.inspera.db.ContentPresentationDataAccess" %>
<%@ page import="no.inspera.utils.Parameters" %>
<%@ page import="no.inspera.applications.publish.datamodel.ContentRevision" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="no.inspera.applications.publish.datamodel.assessment.*" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%
    Parameters params=Parameters.create(request);
//    final Marketplace mp = MarketplaceDataAccess.getInstance().getMarketplaceFromName("pedal");
//    final long id = BaseObjectDataAccess.getInstance().getObjectIdFromLogicalName("pedal_survey", mp.getMarketplaceId());
    final ContentRevision rev = ContentPresentationDataAccess.getInstance().getLiveContentRevisionWithEffectiveLanguage("pedal_survey", 2, params.getMarketplaceId());
    QTIAssessment ass=(QTIAssessment) rev;
    final QTIUserAssessment[] qtis = AssessmentDataAccess.getInstance().getUserAssessmentByCiId(rev.getContentItemId(), params.getMarketplaceId(), params.getLanguageId());
%>
<html>
  <head><title>Survey results</title></head>
  <link rel="stylesheet" href="/jsp/pedal-ng/pedal-ng.css"/>
  <style>
      body{text-align:left;}
  </style>
  <body>
  <div>Results of survey: <%=rev.getTitle()%></div>
  <hr/>
  <%
      SimpleDateFormat f= new SimpleDateFormat("dd.MM.yyyy");
      final QTIQuestion[] questions = ass.getQuestions();
      for (QTIQuestion question : questions) {
          %>
                    <fieldset>
                        <legend><%=question.getTitle()%></legend>
                    </fieldset>
            <%
      }
      for (QTIUserAssessment qti : qtis) {
          %>User: <%=qti.getUserId()%>, date:<%=f.format(qti.getAssessmentDate().getTime())%><%
          final QTIUserAnswer[] answers = qti.getUserAnswers();
          for (QTIUserAnswer answer : answers) {
              %>
                    <%=ass.getQuestion(answer.getQuestionId()).getTitle()%>
                <%
          }
      }
  %>
  
  </body>
</html>